function dataLoadJSON(file_desc_value,file_desc_name,file_desc_names_complete,file_property_values,model_file,property_name)
addpath('./jsonlab')
%file_desc_value: csv file that contains the descriptors values
%file_desc_names: excel file containing the descriptors names
%file_desc_names_complete: excel file containing the names of all the
%descriptors were admitted to descriptor selection software
%file_property_values: csv file that contains the property values
%mod_file: text file containing the models with descriptors selected in each

%load files
values = csvread(file_desc_value); %descriptors values
[nr,nc]=size(values); %nc --> number of descriptors
val_prop = csvread(file_property_values); %vector of property values
[x names_reducido] = xlsread(file_desc_name); %"names_reducido" contains descriptors names 
[x names_completo] = xlsread(file_desc_names_complete); %"names_completo" contains  descriptores completo que se ingresarona a DELPHOS

new_values = [values val_prop];
scatt_values = [val_prop values];

%--------------------- read model file -----------------------
sep = ',';
fid=fopen(model_file,'r');
file=fscanf(fid,'%c');
fclose(fid);
M=strread(file,'%s','delimiter','\n');
cant_total_model = length(M)/2;
mat_models= cell(cant_total_model);
%names_reducido = cell(nc,1);
for i=1:length(M)
   if (mod(i,2)~= 0) %descriptors index
       temp=strread(M{i},'%s','delimiter',sep);
        for j=1:length(temp)
             if (j == 1)
                str1 = strrep(temp{j},'(','');
                str2 = strrep(str1,')','');
                mat_models{i,j}=str2double(str2);
             else
                mat_models{i,j}=str2double(temp{j});
             end
        end
%   else % nombres de los descriptores
%      desc_name_by_model = strread(M{i},'%s','delimiter',sep);
%      for ind=1:length(desc_name_by_model)
%          desc_name = desc_name_by_model{ind};
%          if (ispresent(desc_name,names_reducido)==0) % si no esta guardado
%            names_reducido{ind_name} = desc_name;
%            ind_name = ind_name+1;
%          end
%     end
   end
end

models = cell(cant_total_model,1);
for i=1:cant_total_model
    models{i} = strcat('M', num2str(i));    
end
[sr,sc]=size(models); % use sr

%------------------- links structure for view 1 --------------
nr_omatrix = nc*fix(nc/2);
ind_mi = 1;
ind = 1;
for j=1:nc   %for column 
    for i = j+1:nc  
        val_SP_desc = corr(new_values(:,i),new_values(:,j),'Type','Spearman');
        val_KD_desc = corr(new_values(:,i),new_values(:,j),'Type','Kendall');
        mutual_inf = mut_inf(new_values(:,i),new_values(:,j));
        arr_mut_inf(ind_mi) = mutual_inf;       
        ind_mi = ind_mi + 1;
        struct_links_view1_spearman(ind) = struct('source',j-1,'target',i-1,'value',num2str(val_SP_desc));
        struct_links_view1_kendall(ind) = struct('source',j-1,'target',i-1,'value',num2str(val_KD_desc));
        struct_links_view1_entropy(ind) = struct('source',j-1,'target',i-1,'value',num2str(mutual_inf));
        if ind<nr_omatrix
             ind=ind+1;
        end
    end
end

%arr_mut_inf
perce_25_mi = prctile(arr_mut_inf,25);
perce_50_mi = prctile(arr_mut_inf,50);
perce_75_mi = prctile(arr_mut_inf,75);
perce_100_mi = prctile(arr_mut_inf,100);


  
%-----------------nodes structure--------------------------------

for q=1:nc
    correlSP_descrip_prop = corr(new_values(:,nc+1),new_values(:,q),'Type','Spearman');
    correlKD_descrip_prop = corr(new_values(:,nc+1),new_values(:,q),'Type','Kendall');
    conditional_entropy = cond_entropy(new_values(:,nc+1),new_values(:,q)); % conditional entropy of the descriptor known the value of the property
    index_desc = find(strcmp(names_completo, names_reducido{q})); %descriptor index 
    cant_aparece =  numb_models(mat_models,index_desc); % find index in "mat_models"
    struct_nodes_view1_spearman(q) = struct('name',names_reducido{q},'totalMod',cant_total_model,'global',num2str(correlSP_descrip_prop),'model',cant_aparece);
    struct_nodes_view1_kendall(q) = struct('name',names_reducido{q},'totalMod',cant_total_model,'global',num2str(correlKD_descrip_prop),'model',cant_aparece);
    
    struct_nodes_view1_entropy(q) = struct('name',names_reducido{q},'totalMod',cant_total_model,'global',num2str(conditional_entropy),'model',cant_aparece,'p25',perce_25_mi,'p50',perce_50_mi,'p75',perce_75_mi,'p100',perce_100_mi);
    struct_nodes_view2_entropy(q) = struct('name',names_reducido{q},'totalMod',cant_total_model,'global',num2str(conditional_entropy),'model',cant_aparece);
  
    struct_nodes_view2_spearman(q) = struct('name',names_reducido{q},'totalMod',cant_total_model,'global',num2str(correlSP_descrip_prop),'model',cant_aparece);
    struct_nodes_view2_kendall(q) = struct('name',names_reducido{q},'totalMod',cant_total_model,'global',num2str(correlKD_descrip_prop),'model',cant_aparece);
    struct_nodes_view3(q) = struct('name',names_reducido{q},'totalMod',cant_total_model,'global',num2str(0),'model',cant_aparece);    
end

%add the models to the node structure of the view 3
ind =nc + 1;
for i = 1:sr
   struct_nodes_view3(ind) = struct('name',models{i},'totalMod',cant_total_model,'global',num2str(0),'model',0);    
   ind = ind +1;
end




%------------------- links structure for view 2 -------------
 [row,col] = size(names_reducido);
 %  obtener los dos indices y si los dos indices estan en la misma
 %  fila estn en el mismo modelo a la vez
 ind_view2 = 1;
 for i= 1:row
    index_1 = find(strcmp(names_completo, names_reducido{i}));
    for j=i+1:row 
         index_2 = find(strcmp(names_completo, names_reducido{j}));
         cantidad = appear_together(mat_models,index_1,index_2);
         struct_links_view2_spearman(ind_view2) = struct('source',i-1,'target',j-1,'value',num2str(cantidad));  
         struct_links_view2_kendall(ind_view2) = struct('source',i-1,'target',j-1,'value',num2str(cantidad)); 
         struct_links_view2_entropy(ind_view2) = struct('source',i-1,'target',j-1,'value',num2str(cantidad));  
         ind_view2 = ind_view2 + 1;
    end
 end

%----------------- links structure for view 3 --------
ind_view3 = 1;
for i=1:row
    index = find(strcmp(names_completo, names_reducido{i}));
    arr_mod = present_in_mod(mat_models,index,cant_total_model); 
    [ar,ac] = size(arr_mod);
    for j=1:ar
       if (~isempty(arr_mod{j}))
           struct_links_view3(ind_view3) = struct('source',(row +arr_mod{j})-1,'target',i-1,'value',1);  
           ind_view3 = ind_view3 + 1;
       end
    end
end

%text file with descriptors and property names and csv file with values 
%csvwrite('./output data/dataScatterplot.csv',scatt_values');

%use json for the scatterplot values
savejson('',scatt_values','./output data/dataScatterplot.json');

% fid = fopen( './output data/namesDataScatterplot.txt', 'wt' );
% fprintf( fid, '%s\n', property_name);
% for index_n = 1:nc
%   fprintf( fid, '%s\n', names_reducido{index_n});
% end
% fclose(fid);

%use json for the names
savejson('',[property_name;names_reducido],'./output data/namesDataScatterplot.json');

%file view1 for SPEARMAN correlation
structure_final_view1_spearman = struct('nodes', struct_nodes_view1_spearman, 'links',struct_links_view1_spearman);
savejson('',structure_final_view1_spearman,'./output data/data_view1_SP.json');

%file view1 KENDALL correlation
structure_final_view1_kendall = struct('nodes', struct_nodes_view1_kendall, 'links',struct_links_view1_kendall);
savejson('',structure_final_view1_kendall,'./output data/data_view1_KD.json');

%file view1 for entropy
structure_final_view1_entropy = struct('nodes', struct_nodes_view1_entropy, 'links',struct_links_view1_entropy);
savejson('',structure_final_view1_entropy,'./output data/data_view1_entropy.json');

%file view2 for entropy
structure_final_view2_entropy = struct('nodes', struct_nodes_view2_entropy, 'links',struct_links_view2_entropy); 
savejson('',structure_final_view2_entropy,'./output data/data_view2_entropy.json');

%file view2 for SPEARMAN correlation
structure_final_view2_spearman = struct('nodes', struct_nodes_view2_spearman, 'links',struct_links_view2_spearman); 
savejson('',structure_final_view2_spearman,'./output data/data_view2_SP.json');

%file view2 KENDALL correlation
structure_final_view2_kendall = struct('nodes', struct_nodes_view2_kendall, 'links',struct_links_view2_kendall); 
savejson('',structure_final_view2_kendall,'./output data/data_view2_KD.json');

%file view3
structure_final_view3 = struct('nodes', struct_nodes_view3, 'links',struct_links_view3); 
savejson('',structure_final_view3,'./output data/data_view3.json');